###############################################################################
#                                                                             #
# IAR ANSI C/C++ Compiler V6.50.2.4510/W32 for ARM      25/Jun/2013  15:04:43 #
# Copyright 1999-2012 IAR Systems AB.                                         #
#                                                                             #
#    Cpu mode     =  thumb                                                    #
#    Endian       =  little                                                   #
#    Source file  =  C:\Projects\mbed-master\libraries\mbed\common\I2C.cpp    #
#    Command line =  --c++ --no_rtti --no_exceptions -Oh --cpu=Cortex-M4      #
#                    --thumb --dlib_config "C:/Program Files (x86)/IAR        #
#                    Systems/Embedded Workbench 6.5/arm\inc\c\DLib_Config_Ful #
#                    l.h" -e --no_wrap_diagnostics                            #
#                    --diag_suppress=Pa050,Pa084,Pa093,Pa082                  #
#                    -DTARGET_LPC4330_M4 -DTARGET_M4 -DTARGET_LPC43XX         #
#                    -DTOOLCHAIN_IAR -D__CORTEX_M4 -DARM_MATH_CM4             #
#                    -D__FPU_PRESENT=1 -IC:\Projects\mbed-master\libraries\mb #
#                    ed\common -IC:\Projects\mbed-master\libraries\mbed\targe #
#                    ts\hal -IC:\Projects\mbed-master\libraries\mbed\targets\ #
#                    hal\Freescale -IC:\Projects\mbed-master\libraries\mbed\t #
#                    argets\hal\NXP -IC:\Projects\mbed-master\libraries\mbed\ #
#                    targets\hal\NXP\TARGET_LPC43XX                           #
#                    -IC:\Projects\mbed-master\libraries\mbed\common          #
#                    -IC:\Projects\mbed-master\libraries\mbed\targets\hal     #
#                    -IC:\Projects\mbed-master\libraries\mbed\targets\hal\Fre #
#                    escale -IC:\Projects\mbed-master\libraries\mbed\targets\ #
#                    hal\NXP -IC:\Projects\mbed-master\libraries\mbed\targets #
#                    \hal\NXP\TARGET_LPC43XX -IC:\Projects\build\mbed         #
#                    -IC:\Projects\build\mbed\TARGET_LPC4330_M4 -o            #
#                    C:\Projects\build\mbed\.temp\LPC4330_M4\IAR\.\I2C.o      #
#                    C:\Projects\mbed-master\libraries\mbed\common\I2C.cpp    #
#                    --dependencies C:\Projects\build\mbed\.temp\LPC4330_M4\I #
#                    AR\.\I2C.d -l C:\Projects\build\mbed\.temp\LPC4330_M4\IA #
#                    R\.\I2C.s                                                #
#    List file    =  C:\Projects\build\mbed\.temp\LPC4330_M4\IAR\.\I2C.s      #
#    Object file  =  C:\Projects\build\mbed\.temp\LPC4330_M4\IAR\.\I2C.o      #
#                                                                             #
#                                                                             #
###############################################################################

C:\Projects\mbed-master\libraries\mbed\common\I2C.cpp
      1          /* mbed Microcontroller Library
      2           * Copyright (c) 2006-2013 ARM Limited
      3           *
      4           * Licensed under the Apache License, Version 2.0 (the "License");
      5           * you may not use this file except in compliance with the License.
      6           * You may obtain a copy of the License at
      7           *
      8           *     http://www.apache.org/licenses/LICENSE-2.0
      9           *
     10           * Unless required by applicable law or agreed to in writing, software
     11           * distributed under the License is distributed on an "AS IS" BASIS,
     12           * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     13           * See the License for the specific language governing permissions and
     14           * limitations under the License.
     15           */
     16          #include "I2C.h"
     17          
     18          #if DEVICE_I2C
     19          
     20          namespace mbed {
     21          
     22          I2C *I2C::_owner = NULL;
     23          
     24          I2C::I2C(PinName sda, PinName scl) {
     25              // The init function also set the frequency to 100000
     26              i2c_init(&_i2c, sda, scl);
     27              _hz = 100000;
     28          
     29              // Used to avoid unnecessary frequency updates
     30              _owner = this;
     31          }
     32          
     33          void I2C::frequency(int hz) {
     34              _hz = hz;
     35          
     36              // We want to update the frequency even if we are already the bus owners
     37              i2c_frequency(&_i2c, _hz);
     38          
     39              // Updating the frequency of the bus we become the owners of it
     40              _owner = this;
     41          }
     42          
     43          void I2C::aquire() {
     44              if (_owner != this) {
     45                  i2c_frequency(&_i2c, _hz);
     46                  _owner = this;
     47              }
     48          }
     49          
     50          // write - Master Transmitter Mode
     51          int I2C::write(int address, const char* data, int length, bool repeated) {
     52              aquire();
     53          
     54              int stop = (repeated) ? 0 : 1;
     55              int retval = i2c_write(&_i2c, address, data, length, stop);
     56          
     57              return retval;
     58          }
     59          
     60          int I2C::write(int data) {
     61              return i2c_byte_write(&_i2c, data);
     62          }
     63          
     64          // read - Master Reciever Mode
     65          int I2C::read(int address, char* data, int length, bool repeated) {
     66              aquire();
     67          
     68              int stop = (repeated) ? 0 : 1;
     69              int retval = i2c_read(&_i2c, address, data, length, stop);
     70          
     71              return retval;
     72          }
     73          
     74          int I2C::read(int ack) {
     75              if (ack) {
     76                  return i2c_byte_read(&_i2c, 0);
     77              } else {
     78                  return i2c_byte_read(&_i2c, 1);
     79              }
     80          }
     81          
     82          void I2C::start(void) {
     83              i2c_start(&_i2c);
     84          }
     85          
     86          void I2C::stop(void) {
     87              i2c_stop(&_i2c);
     88          }
     89          
     90          } // namespace mbed
     91          
     92          #endif


 

 


Errors: none
Warnings: none
